<?php
/*****************************************

  Google Maps ShortCode
  by:tenderfeel(tenderfeel@gmail.com)

-------------------------------------------
  使用方法
-------------------------------------------
  記事本文内で[Gmap] と書く。
  
  属性の設定は次のように。
  [Gmap width="500px" lat="35.689184"]

  間に何か文字とかを入れた場合はタブ内に表示。
　
  [Gmap]

  <em>Hellow</em>

  何かコメントを入れてください

  [/Gmap]
  
-------------------------------------------
  属性一覧
-------------------------------------------
  カッコはデフォルト値。値はすべて文字列で。
  デフォルトの座標は東京都庁になっています。
  変更する場合は$defaultの値を修正する。

  @width ---------- (100%) 地図の横幅
  @height --------- (500px) 地図の縦幅
  @lat ------------ (35.689184) マーカーlat座標
  @lng ------------ (139.691648) マーカーlng座標
  @zoom ----------- (10) 拡大率[0～20]
  @marker --------- (true)　マーカーを表示するかどうか
  @zoomcontroler -- (false) ズームコントローラーを表示するかどうか
  @controler ------ (true)　コントローラーを表示するかどうか
  @navlabel ------- (false)　ナビゲーションレベルコントローラーを表示するかどうか
  @maptype -------- (3)　地図タイプ切り替え[2 or 3]
  @scale ---------- (false) スケールコントローラを表示するかどうか
  @overview ------- (true)　右下の縮小地図
  @wheelzoom ------ (false)　ホイールでのズーム操作
  @clickzoom ------ (true)　ダブルクリックでのズーム操作
  @html ----------- ("")　情報ウィンドウのHTML

*******************************************/
  //GoogleMaps APIキー

  $google_apikey ="ADD_YOUR_API_KEY";

/******************************************/

function googlemap_shortcode($atts,$content=null) {
	
	$default = array(
		'width'=>'100%',
		'height'=>'500px',
		'lat' => '35.689184',
		'lng' => '139.691648',
		'zoom'=> '10',
		'marker'=>'true',
		'zoomcontroler'=>'false',
		'controler'=>'true',
		'navlabel'=>'false',
		'maptype'=>'3',
		'scale'=>'false',
		'overview'=>'true',
		'wheelzoom'=>'false',
		'clickzoom'=>'true',
		'html'=>'""'
		);
	$atts = shortcode_atts($default, $atts);

	if($content!=null){
		$atts['html'] = '"'.preg_replace("/\r|\n/","<br />",trim(wp_filter_kses($content))).'"';
	}
	
	$script ='<script type="text/javascript" src="http://www.google.com/jsapi?key='.$google_apikey.'"></script>'."\n";
	
	$script .= "<script type=\"text/javascript\">\n//<![CDATA[\n";
	$script .= "var gmConfig = {'gmLat':".$atts['lat'].",'gmLng':".$atts['lng'].",'gmDivID':'gmap','gmScope':".$atts['zoom'].",'markerAdd':".$atts['marker'].",";
	$script .="'LMap_Controler':".$atts['controler'].",";
	$script .="'SmallZoomControl':".$atts['zoomcontroler'].",'NavLabelControl':".$atts['navlabel'].",";
	switch($atts['maptype']){
		case '2':
			$script .="'Type3_Controler':false,Type2_Controler':true,";
		break;
		default:
			$script .="'Type3_Controler':true,'Type2_Controler':false,";
	}
	$script .="'Scale_Controler':".$atts['scale'].",'OV_Controler':".$atts['overview'].",'WheelZoom':".$atts['wheelzoom'].",'DClickZoom':".$atts['clickzoom'].",";
	$script .= "WindowHTML:".$atts['html']."}\n";
	$script .="//]] >\n</script>";
	$script.='<script type="text/javascript" src="'.get_bloginfo('template_directory').'/gmap.js"></script>'."\n";
	$script.='<div id="gmap" style="width:'.$atts['width'].';height:'.$atts['height'].'"></div>';
EOM;
	return $script;
}

add_shortcode('Gmap', 'googlemap_shortcode');
?>